/* memory.h */

/* interface entre le gc et le runtime */
/* pour le gc Lang & Dupont avec generations */

#ifndef _memory_
#define _memory_


#include "gc_aux.h"
#include "config.h"
#include "mlvalues.h"
#include "stat_alloc.h"

#ifdef ANSI

extern value alloc_in_free_list (blocksize len);
extern value small_alloc (header hdr, blocksize len);
extern value big_alloc (header hdr, blocksize len);
extern char *temp_alloc (blocksize size);
extern void temp_free (void);
extern void init_memory(unsigned long total_sz,
                        unsigned long heap_sz,
                        unsigned long generation_sz,
                        unsigned long static_sz);
#else /* ANSI */

extern value alloc_in_free_list ();
extern value small_alloc ();
extern value big_alloc ();
extern char *temp_alloc ();
extern void temp_free ();
extern void init_memory();

#endif /* ANSI */

#define IS_ALLOCATED(val) (IS_IN_HEAP(val) || IS_YOUNG(val))

#define MODIFY(ptr, val)                                                      \
/* value *ptr; value val; */                                                  \
  { *(ptr) = (val);                                                           \
    if (IS_BLOCK(val) && IS_IN_HEAP(ptr) && IS_YOUNG(val)) {                  \
      *ref_index++ = (value *) (ptr);                                         \
      if (ref_index == ref_table_end){                                        \
        SETUP_FOR_GC;                                                         \
        (void) call_minor_gc (0);                                             \
        RESTORE_AFTER_GC;                                                     \
      }                                                                       \
    }                                                                         \
  }

extern value **ref_index;
extern value *ref_table[];
extern value **ref_table_end;

extern address young_start, young_end;
extern address heap_start, heap_end;

#endif /* _memory_ */
