/* meta.c : primitives pour le toplevel */

#include "mlvalues.h"
#include "alloc.h"
#include "memory.h"
#include "globals.h"
#include "stat_alloc.h"

value realloc_global(size)      /* ML */
     value size;
{
  blocksize requested_size, actual_size, i;
  PUSH_ROOTS (new_global_data, 1);

  requested_size = CINT(size);
  actual_size = SIZE(global_data);
  if (requested_size >= actual_size) {
    requested_size = (requested_size + 0x100) & 0xFFFFFF00;
    ALLOC_INIT(new_global_data [0], MAKE_HEADER(requested_size, 0),
               requested_size, MLINT(0));
    for (i = 0; i < actual_size; i++)
      MODIFY(&FIELD(new_global_data [0], i), FIELD(global_data, i));
    FIELD(new_global_data [0], GLOBAL_DATA) = new_global_data [0];
    /* Ne peut pas creer de racines inverses -> on n'appelle pas MODIFY */
    global_data = new_global_data [0];
  }
  POP_ROOTS ();
  return atom(0);
}
    
    
value static_alloc(size)        /* ML */
     value size;
{
  return (value) stat_alloc(CINT(size));
}

value static_free(blk)          /* ML */
     value blk;
{
  stat_free((char *) blk);
  return atom(0);
}

value static_resize(blk, new_size) /* ML */
     value blk, new_size;
{
  return (value) stat_resize((char *) blk, CINT(new_size));
}

value obj_block(tag, size) /* ML */
     value tag, size;
{
  value res;
  blocksize sz, i;
  int tg;
  header hdr;

  sz = CINT(size);
  tg = CINT(tag);
  if (sz == 0) return atom(tg);
  hdr = MAKE_HEADER(sz, tg);
  ALLOC(res, hdr, sz);
  for (i = 0; i < sz; i++)
    FIELD(res, i) = MLINT(0);

  return res;
}

